use strict; use warnings;
use PadWalker;

# All these bugs were reported by Dave Mitchell; he's the first
# person to get his very own test script.

print "1..7\n";

# Does PadWalker work if it's called from a closure?
sub f {
    my $x = shift;
    sub {
        my $t = shift;
        my $x_val = ${PadWalker::peek_my(0)->{'$x'}};
        print ($x_val eq $x ? "ok $t\n" : "not ok $t # $x_val\n");
    }
}

f(6)->(1);

# Even if the sub 'f' has been blown away?
my $f = f('eh?');
undef &f;
$f->(2);

# If there's no reference to the value, we expect to get undef;
# if there is, we expect to get the value.
sub h {
    my $x = my $y = 'fixed';
    sub {
      my $vals = PadWalker::peek_my(0);
      my $x_val = ${$vals->{'$x'}};
      my $y_val = ${$vals->{'$y'}};
      print (!defined($x_val)  ? "ok 3\n" : "not ok 3 # $x_val\n");
      print ($y_val eq 'fixed' ? "ok 4\n" : "not ok 4 # $y_val\n");
      my $unused = $y;
    }
}
h()->();

# How well do we cope with one variable masking another?

my $x = 1;
sub g {
    my $x = 2;
    my $v_x = ${PadWalker::peek_my(0)->{'$x'}};
    print ($v_x eq 2 ? "ok 5\n" : "not ok 5 # $v_x\n");
}                                                                           
g();

no warnings 'misc'; # I know it masks an earlier declaration -
                    # that's the whole point!
my $x = 'final value';
my $v_x = ${PadWalker::peek_my(0)->{'$x'}};
print ($v_x eq $x ? "ok 6\n" : "not ok 6 # $v_x\n");

# An 'our' variable should mask a 'my':
our $x;
$x = $x; # Stop old perls from giving 'used only once' warning
print (exists PadWalker::peek_my(0)->{'$x'} ? "not ok 7\n" : "ok 7\n");
